*------------------ Core Identification and Structure ------------------*
label var 	id							"Unique ID"
label var	survey_round				"Survey round"
label var	treat						"Treatment status"
label var	consent 					"Respondent consent"

*------------------ Demographics and Background ------------------*
label var	sex							"Sex"
label var	sex_base					"Sex at baseline"
label var	yob							"Year of birth"
label var	age							"Age"
label var	age_base					"Age at baseline"
label var	educ 						"Level of education attained"
label var	educ_high					"Completed middle school"
label var	educ_high_base				"Completed middle school at baseline"
label var	resid_since					"Years lived in current residence"
label var	resid_prev_regi				"Region of previous residence"
label var	first_formal				"First formal job"
label var	recent_migr					"Recent migrant"

*------------------ Employment and Work ------------------*
label var 	last7d_working              "Worked in the last 7 days"
label var 	bef_eif_job					"Job before working for company"
label var	eif_still_work				"Still working at company"
label var 	eif_pos 					"Position at company"
label var	last7d_status 				"Current work activity status"
label var	currwork_sector				"Current work sector"
label var	last7d_hours_worked			"Hours worked in the last 7 days"
label var	last7d_days_worked			"Days worked in the last 7 days"
label var	employed					"Employed"
label var	eif_still_work_end			"Still works at construction company at endline"
label var   month_hours_worked          "Monthly hours worked"
label var   eif_quit_reason             "Reason for leaving company"
label var   whyleft_endcontract3        "Contract not renewed"

*------------------ Earnings and Wages ------------------*
label var	earn_last_month 			"Earnings in the last month from main activity"
label var	earn_avg_month 		    	"Average monthly earnings from main activity"
label var	earn_avg_month_range		"Average monthly earnings range from main activity"
label var	earn_change_aug19 			"Change in monthly earnings since August 2019"
label var	earn_dir_change_aug19		"Upward or downward change in monthly earnings since August 2019"
label var	earn_amount_change_aug19	"Amount of change in monthly earnings since August 2019"
label var	earn_change_jan20 			"Change in monthly earnings since January 2020"
label var	earn_dir_change_jan20		"Upward or downward change in monthly earnings since January 2020"
label var	earn_amount_change_jan20	"Amount of change in monthly earnings since January 2020"
label var	last7d_earn_avg			 	"Average earnings in the last 7 days"
label var	last7d_earn_freq		 	"Earnings frequency in the last 7 days"
label var	last7d_oj_earn			 	"Earnings from other job in the last 7 days"
label var	last7d_oj_earn_range	 	"Earnings range from other job in the last 7 days"
label var	inter_earnlstmonth_mid		"Last earnings (mid-tier estimate)"
label var	inter_earnlstmonth_mid_base	"Last earnings at baseline"
label var	inter_earnlstmonth_low		"Last earnings (low estimate)"
label var	inter_earnlstmonth_top		"Last earnings (high estimate)"
label var	inter_earnlstmonth_mid_log	"Log last earnings"
label var	inter_earnlstmonth_mid_ihs	"IHS last earnings"
label var	inter_earnlstmonth_mid_log_base	"Log last earnings at baseline"
label var	inter_earnlstmonth_mid_ihs_base	"IHS last earnings at baseline"
label var	hourly_wage					"Hourly wage"
label var	hourly_wage_base			"Hourly wage at baseline"
label var	grade_2019_admin			"Supervisor grade 2019"
label var	grade_2019_admin_base		"Supervisor grade 2019 at baseline"
label var   inter_earnavgmonth_low      "Average earnings (low estimate)"
label var   inter_earnavgmonth_mid      "Average earnings (mid estimate)"
label var   inter_earnavgmonth_top      "Average earnings (high estimate)"
label var   inter_earnlstmonth_low_base "Last earnings at baseline (low estimate)"
label var   inter_earnlstmonth_top_base "Last earnings at baseline (high estimate)"

*------------------ Positions ------------------*
la var	pos_secu "Security agent helper"
la var	pos_maso "Mason"
la var	pos_scra "Iron worker"
la var	pos_form "Form setter"
la var	pos_carp "Carpenter"
la var	pos_labo "Laborer"
la var	pos_driv "Driver help"
la var	pos_topo "Topographer/Topographer helper"
la var	pos_flag "Flag holder"
la var	pos_spec "Specialized laborer/worker"

*------------------ Big Five Personality Traits ------------------*
label var	big5_extrovert				"Big 5 personality: extrovert"
label var	big5_critic					"Big 5 personality: critical"
label var	big5_reliable 				"Big 5 personality: reliable, disciplined"
label var	big5_anxious 				"Big 5 personality: anxious"
label var	big5_open 					"Big 5 personality: open"
label var	big5_shy 					"Big 5 personality: shy"
label var	big5_sympathetic 			"Big 5 personality: sympathetic"
label var	big5_disorganized			"Big 5 personality: disorganized"
label var	big5_calm					"Big 5 personality: calm"
label var	big5_conventional			"Big 5 personality: conventional"
label var	big5_avg_consc				"Average conscientiousness"
label var	big5_avg_consc_base			"Average conscientiousness at baseline"
label var	big5_avg_extra				"Average extraversion"
label var	big5_avg_extra_base			"Average extraversion at baseline"
label var	big5_avg_agreea				"Average agreeableness"
label var	big5_avg_agreea_base		"Average agreeableness at baseline"
label var	big5_avg_emoti				"Average emotional stability"
label var	big5_avg_emoti_base			"Average emotional stability at baseline"
label var	big5_avg_open				"Average openness to experience"
label var	big5_avg_open_base			"Average openness to experience at baseline"

*------------------ Conscientiousness Traits - Organization ------------------*
label var	trait_tidy					"Trait: Keep things tidy and in order"
label var	trait_tidy_base				"Trait: Keep things tidy and in order at baseline"
label var	trait_follow_schedule		"Trait: Follow a schedule"
label var	trait_follow_schedule_base	"Trait: Follow a schedule at baseline"
label var	trait_followup_method 		"Trait: Use method to follow-up"
label var	trait_followup_method_base	"Trait: Use method to follow-up at baseline"
label var	trait_organize_schedule		"Trait: Organize schedule"
label var	trait_organize_schedule_base "Trait: Organize schedule at baseline"
label var	trait_clean_up 				"Trait: Cleaning up after yourself"
label var	trait_clean_up_base			"Trait: Cleaning up after yourself at baseline"
label var	trait_orga_pers_spaces		"Trait: Keeping personal spaces organized"
label var	trait_orga_pers_spaces_base	"Trait: Keeping personal spaces organized at baseline"
label var	trait_keep_organized		"Trait: Keep things well organized"
label var	trait_keep_organized_base	"Trait: Keep things well organized at baseline"
label var	trait_keep_tidy     		"Trait: Keep things in order"
label var	trait_keep_tidy_base		"Trait: Keep things in order at baseline"

*------------------ Conscientiousness Traits - Industriousness ------------------*
label var	trait_make_plan 			"Trait: Make plans"
label var	trait_make_plan_base		"Trait: Make plans at baseline"
label var	trait_work_goals			"Trait: Work to reach your goals"
label var	trait_work_goals_base		"Trait: Work to reach your goals at baseline"
label var	trait_set_clear_goals 		"Trait: Fix clear goals"
label var	trait_set_clear_goals_base 	"Trait: Fix clear goals at baseline"
label var	trait_set_high_standards	"Trait: Set high standards"
label var	trait_set_high_standards_base "Trait: Set high standards at baseline"
label var	trait_change_setback 		"Trait: Change ways of working towards a goal after a setback"
label var	trait_change_setback_base 	"Trait: Change ways of working towards a goal after a setback at baseline"
label var	trait_work_hard 			"Trait: Work hard to succeed"
label var	trait_work_hard_base 		"Trait: Work hard to succeed at baseline"
label var	trait_focus_goals			"Trait: Focus on most important goals"
label var	trait_focus_goals_base		"Trait: Focus on most important goals at baseline"
label var	trait_make_plan_for_goal 	"Trait: Make plans to reach a goal"
label var	trait_make_plan_for_goal_base "Trait: Make plans to reach a goal at baseline"
label var	trait_keep_trying_if_fail	"Trait: Keep trying after failing"
label var	trait_keep_trying_if_fail_base "Trait: Keep trying after failing at baseline"

*------------------ Conscientiousness Traits - Responsibility ------------------*
label var	trait_attentive_others		"Trait: Be there when others need me"
label var	trait_attentive_others_base	"Trait: Be there when others need me at baseline"
label var	trait_others_dependent		"Trait: Other people depend on me"
label var	trait_others_dependent_base	"Trait: Other people depend on me at baseline"
label var	trait_keep_promises 		"Trait: Keep promises"
label var	trait_keep_promises_base 	"Trait: Keep promises at baseline"
label var	trait_fulfill_promises		"Trait: Fulfill my promises and engagements"
label var	trait_fulfill_promises_base	"Trait: Fulfill my promises and engagements at baseline"
label var	trait_up_to_responsib		"Trait: Live up to responsibilities"
label var	trait_up_to_responsib_base	"Trait: Live up to responsibilities at baseline"
label var	trait_respect_engagements	"Trait: Respect engagements"
label var	trait_respect_engagements_base "Trait: Respect engagements at baseline"
label var	trait_others_count 			"Trait: Other people are counting on me"
label var	trait_others_count_base 	"Trait: Other people are counting on me at baseline"
label var	trait_fulfill_duty 			"Trait: Fulfill my duties and obligations"
label var	trait_fulfill_duty_base 	"Trait: Fulfill my duties and obligations at baseline"
label var	trait_manage_responsib		"Trait: Manage responsibilities" 
label var	trait_manage_responsib_base	"Trait: Manage responsibilities at baseline" 

*------------------ Conscientiousness Traits - Punctuality ------------------*
label var	trait_remorse_late			"Trait: Show remorse if late at a meeting"
label var	trait_remorse_late_base		"Trait: Show remorse if late at baseline"
label var	trait_earlier_meet 			"Trait: Go to meeting earlier"
label var	trait_earlier_meet_base		"Trait: Go to meeting earlier at baseline"
label var	trait_avoid_late			"Trait: Avoid being late to a meeting or work"
label var	trait_avoid_late_base		"Trait: Avoid being late to a meeting or work at baseline"
label var	trait_avoid_procrast		"Trait: Avoid procrastination"
label var	trait_avoid_procrast_base	"Trait: Avoid procrastination at baseline"
label var	trait_on_time 				"Trait: Punctuality"
label var	trait_on_time_base 			"Trait: Punctuality at baseline"
label var	trait_late_meetings 		"Trait: Being late to meetings"
label var	trait_late_meetings_base 	"Trait: Being late to meetings at baseline"

*------------------ Conscientiousness Traits - Averages ------------------*
lab var	    trait_avg_orga          	"Average organisational trait"
lab var	    trait_avg_orga_base        	"Average organisational trait at baseline"
lab var	    trait_avg_indus         	"Average industriousness trait"
lab var	    trait_avg_indus_base       	"Average industriousness trait at baseline"
lab var	    trait_avg_resp          	"Average responsibility trait"
lab var	    trait_avg_resp_base        	"Average responsibility trait at baseline"
lab var	    trait_avg_punc          	"Average punctuality trait"
lab var	    trait_avg_punc_base        	"Average punctuality trait at baseline"

*------------------ COVID-19 Protection and Symptoms ------------------*
label var 	covid_protect_m1			"Protection measure: wearing masks home"
label var 	covid_protect_m2			"Protection measure: social distancing" 
label var 	covid_protect_m3			"Protection measure: travel reduction"
label var 	covid_protect_m4			"Protection measure: wearing gloves"
label var 	covid_protect_m5			"Protection measure: frequent hand washing"
label var 	covid_protect_m6			"Protection measure: avoid public spaces"
label var   covid_protect_m7            "Protection measure: pray"
label var   covid_protect_m8            "Protection measure: other"
label var	covid_sympt_cough			"Respondent or family member symptom: cough"
label var	covid_sympt_diff_breath 	"Respondent or family member symptom: difficulty breathing"
label var	covid_sympt_sore_throat		"Respondent or family member symptom: sore throat"
label var	covid_sympt_running_nose 	"Respondent or family member symptom: running nose"
label var	covid_sympt_muscle_pain		"Respondent or family member symptom: muscle pain"
label var	covid_sympt_headache		"Respondent or family member symptom: headache"	
label var	covid_sympt_tiredness 		"Respondent or family member symptom: tiredness"
label var	covid_sympt_diarrhea 		"Respondent or family member symptom: diarrhea"
label var	covid_sympt_loss_smell 		"Respondent or family member symptom: loss of smell/taste"
label var	covid_sympt_fever 			"Respondent or family member symptom: fever"
label var	covid_meas_count			"Number of measures taken"
label var	covid_effect_meas_count		"Number of effective measures taken"
label var	covid_any_sympt				"Display of symptoms"

*------------------ COVID-19 Work and Financial Impacts ------------------*
label var 	covid_change_work_cond1		"Changing work conditions: job loss"
label var 	covid_change_work_cond2		"Changing work conditions: decrease in days worked"
label var 	covid_change_work_cond3		"Changing work conditions: increase in days worked"
label var 	covid_change_work_cond4		"Changing work conditions: decrease in daily work hours"
label var 	covid_change_work_cond5		"Changing work conditions: increase in daily work hours"
label var	covid_change_work_any		"Contractual terms changed"
label var	covid_hhm_lost_job			"Lost main source of income"
label var	covid_feb_revenue			"Change in revenue in comparison to February"
label var	covid_feb_revenue_lower		"Income from job is lower"
label var	covid_feb_tot_revenue 		"Change in household total revenue in comparison to February"
label var	covid_feb_tot_revenue_lower	"Overall household income lower"
label var	covid_feb_remittances		"Change in revenues from transfers, donations and remittances in comparison to February"
label var	covid_feb_remittances_lower	"Transfers and gifts received lower"
label var	covid_feb_food_expenditures	"Change in food expenditures in comparison to February"
label var	covid_feb_food_exp_higher	"Food expenditures higher"
label var	covid_feb_health_expenditures "Change in health expenditures in comparison to February"
label var	covid_feb_health_exp_higher	"Health expenditures higher"
label var	covid_feb_edu_expenditures	"Change in education expenditures in comparison to February"
label var	covid_feb_edu_exp_higher	"Education expenditures higher"
label var	covid_feb_transfers_abroad 	"Change in transfers and donations to abroad in comparison to February"
label var	covid_feb_transf_abroad_higher "Transfers and gifts given higher"
label var	covid_feb_savings			"Change in savings in comparison to February"
label var	covid_feb_savings_lower		"Savings lower"
label var	covid_feb_debt				"Change in debt in comparison to February"
label var	covid_feb_debt_higher		"Borrowing higher"

*------------------ Household Characteristics ------------------*
label var	hh_n_above_18				"# adults in household"
label var	hh_n_above_18_base			"# adults in household at baseline"
label var	hh_n_children				"# children in household"
label var	hh_n_children_base			"# children in household at baseline"
label var	hh_n_bedrooms 				"# beds in household"
label var	hh_n_bedrooms_base			"# beds in household at baseline"
label var	hh_revenue_range_r1r2		"Weekly household revenue range, round 1 and 2"
label var	hh_revenue_range_r3			"Weekly household revenue range, round 3"
label var	hh_formal_savings			"Household formal savings"
label var	hh_informal_savings 		"Household informal savings"
label var	hh_formal_debt 				"Household formal debt"
label var	hh_informal_debt 			"Household informal debt"
label var	total_debt_mid				"Total household debt"
label var	total_debt_mid_base			"Total household debt at baseline"
label var	total_save_mid				"Total household savings"
label var	total_save_mid_base			"Total household savings at baseline"
label var	hhincome_mid				"Household income"
label var	hhincome_mid_base			"Household income at baseline"

*------------------ Sample and Analysis Variables ------------------*
label var	sample						"Analysis sample"
label var	attritor					"Attrition group"
label var   appears                     "Number of times surveyed"
label var   sample_r1                   "Valid observations in round 1"
label var   sample_r2                   "Valid observations in round 2"
label var   sample_r3                   "Valid observations in round 3"