/*
	Run all scripts
*/

version 18
clear all
set more off
set seed 6129

* !TODO! Change the root directory to your replication files path
global root "C:\Users\wb558768\Downloads\rep-checks\393\PP_SEN_2025_393"

* Set global paths
global data "$root/data"
global outputs "$root/outputs"
global scripts "$root/scripts"

* Create subdirectories if they don't exist
capture mkdir "$data/2_processed"
capture mkdir "$outputs"

* Install required packages if not already installed
sysdir set PLUS "${scripts}/ado"
mata: mata mlib index
local user_commands ietoolkit estout wyoung 
foreach command of local user_commands {
    cap which `command'
    if _rc == 111 {
        ssc install `command'
    }
}

* Install spost13_ado if not available
cap which listcoef 
if _rc == 111 {
    net install spost13_ado, from("https://spost.su.domains")
}



* Run scripts
do "$scripts/1_data-prep/prepare-baseline.do"
do "$scripts/1_data-prep/prepare-followup1.do"
do "$scripts/1_data-prep/prepare-followup2.do"
do "$scripts/1_data-prep/append-rounds.do"
do "$scripts/1_data-prep/variables-creation.do"
do "$scripts/2_analysis/analysis.do"
